#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>


extern char *crypt(const char *key, const char *salt);










char *make_salt(char *s, int s_size) {
 struct	timeval	tv;
 static char	chars[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
 int		ran;
 int		n;

 gettimeofday(&tv, 0);
 srandom(tv.tv_usec + tv.tv_sec);

 for ( n = 0 ; n < s_size - 1 ; n++ ) {
	ran = (int)((double)(sizeof(chars) - 1) * (rand() / (RAND_MAX + 1.0)));
	*s++ = *(chars + ran);
	}

 *s++ = 0;

 s -= s_size;

 return s;
}










char *make_pass(char *s) {
 char		sugar[3];
 char		*salt;
 
 make_salt(sugar, 3);
 
 salt = crypt(s, sugar);

 return salt;
}










int passcmp(char *pass1, char *pass2, int p_size) {
 char		*t_pass;
 char		sugar[3];
 char		*salt;
 int		r, l;

 memcpy(sugar, pass1, 2);
 *(sugar + 2) = 0;

 t_pass = malloc(p_size + 1);
 sprintf(t_pass, "%.*s", p_size, pass2);

 salt = crypt(t_pass, sugar);

 free(t_pass);

 if ((l = strlen(pass1)) == strlen(salt)) {
	r = memcmp(pass1, salt, l);
	return r;
	}
 return -1;
}
